<template>
  <section>
    <!-- Breed Images -->
    <div>
      <div
        class="d-flex flex-column flex-sm-row align-items-center justify-content-between mb-3"
      >
        <h4 class="text-capitalize mb-3">{{ route.params?.breed }}</h4>
        <div
          class="d-flex align-items-baseline justify-content-center"
          style="gap: 12px"
        >
          <span>Show Number of Images</span>
          <div role="group">
            <b-form-input
              v-model="numberOfImages"
              :state="validNumber"
              placeholder="0"
              trim
              type="number"
              max="50"
              min="3"
              style="width: 100px"
            />
            <b-form-invalid-feedback>
              {{ Number(numberOfImages) > 50 ? 'Maximum 50' : 'Minimum 3' }}
            </b-form-invalid-feedback>
          </div>
        </div>
      </div>
      <div
        v-if="!['terrier', 'shiba'].includes(route.params?.breed)"
        class="image-list"
      >
        <div v-for="(image, index) in images" :key="`${image}-${index}`">
          <ImageGrid :image-src="image" hide-information />
        </div>
      </div>
      <ImageSlider
        v-else-if="route.params?.breed === 'terrier'"
        :images="images.map((img) => ({ src: img }))"
        indicators
      />
      <vueper-slides
        v-else
        :visible-slides="3"
        :slide-ratio="1 / 4"
        slide-multiple
        :arrows-outside="false"
        :gap="3"
        fixed-height="350px"
      >
        <vueper-slide v-for="(image, i) in images" :key="i" :image="image" />
      </vueper-slides>
    </div>

    <hr class="my-5" />

    <!-- Sub Breeds -->
    <div v-if="dogSubBreeds.length">
      <h4 class="text-capitalize mb-3">Sub Breeds</h4>
      <div
        v-if="!['terrier', 'shiba'].includes(route.params?.breed)"
        class="image-list"
      >
        <ImageGrid
          v-for="(dog, index) in dogSubBreeds"
          :key="`${dog.subBreed}-${index}`"
          :source="dog"
          :to="`/${route.params?.breed}/${dog.subBreed}`"
          is-sub-breed
        >
          <template #title>
            <h6>{{ dog.subBreed }}</h6>
          </template>
        </ImageGrid>
      </div>
      <ImageSlider
        v-else-if="route.params?.breed === 'terrier'"
        :images="dogSubBreeds"
        indicators
      >
        <template #images="slotProps">
          <b-carousel-slide
            v-for="(dog, index) in slotProps.images"
            :key="`${dog.subBreed}-${index}`"
            :caption="dog.subBreed"
            class="text-capitalize"
          >
            <template #img>
              <ImageGrid
                :source="dog"
                :to="`/${route.params?.breed}/${dog.subBreed}`"
                is-sub-breed
                hide-information
                width="auto"
                :height="350"
                :lazy="false"
              />
            </template>
          </b-carousel-slide>
        </template>
      </ImageSlider>
      <vueper-slides
        v-else
        fixed-height="350px"
        :visible-slides="3"
        :slide-ratio="1 / 4"
        slide-multiple
        :arrows-outside="false"
        :gap="3"
      >
        <vueper-slide
          v-for="(dog, i) in dogSubBreeds"
          :key="i"
          :title="dog.subBreed"
        >
          <template #content>
            <ImageGrid
              :source="dog"
              :to="`/${route.params?.breed}/${dog.subBreed}`"
              is-sub-breed
              hide-information
              :width="350"
              :height="350"
              :lazy="false"
            />
          </template>
        </vueper-slide>
      </vueper-slides>
    </div>
  </section>
</template>

<script setup>
import { onMounted, useRoute, useStore } from '@nuxtjs/composition-api'
import { computed, ref, watch } from 'vue'

import { VueperSlides, VueperSlide } from 'vueperslides'
import 'vueperslides/dist/vueperslides.css'

const route = useRoute()
const store = useStore()

const numberOfImages = ref(3)
const images = ref([])

const validNumber = computed(
  () => Number(numberOfImages.value) >= 3 && Number(numberOfImages.value) <= 50
)

const fetchImages = async () => {
  const breed = route.value.params.breed
  images.value = await store.dispatch('dog/dog_fetchBreedImageUrl', {
    breed,
    numberOfImages: numberOfImages.value,
  })
}

const dogSubBreeds = computed(() =>
  store.state.dog.dog_subBreeds.map((subBreed) => ({
    breed: route.value.params.breed,
    subBreed,
  }))
)

const fetchSubreed = async () => {
  await store.dispatch('dog/dog_fetchSubBreedList', {
    breed: route.value.params.breed,
  })
}

let timeout = 0

watch(numberOfImages, () => {
  clearTimeout(timeout)
  if (validNumber.value) {
    timeout = setTimeout(() => {
      fetchImages()
    }, 500)
  }
})

onMounted(() => {
  fetchImages()
  fetchSubreed()
})
</script>
